/*
 * WhoIsIt -- A program to play an announcement over the computer speakers, of an incoming caller.
 *
 * Copyright (C) 2004, Steve Murphy
 *
 * Steve Murphy <murf@e-tools.com>
 *
 *  This Software is declared to be in the Public Domain. 
 *  Do with it as you darn well please, except don't try to say you wrote it.
 * 
 */

#define LOCAL_AREACODE "307"    /* SET THIS TO YOUR OWN AREACODE */



#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>


char buf2[20000];
char buf3[20000];

void get_vars(void)
{
	char buf1[10000];
	while(fgets(buf1, 10000, stdin))
	{
		if( buf1[0] == '\n' )
		{
			break;
		}
		char *t,*p1,*p2;
		buf1[strlen(buf1)-1]=0;
		strcat(buf2,buf1); strcat(buf2,"--------");
		t = (char *)malloc(strlen(buf1)+1);
		p1=strchr(buf1,':');
		if( p1 )
		{ 
			*p1=0; 
			p2 = p1+2; 
			sprintf(t,"%s=%s", buf1,p2); 
			putenv(t); 
		}
	}
}

void get_answer(void)
{
	char buf1[10000];
	buf3[0]=0;
	fgets(buf1, 10000, stdin);
	buf1[strlen(buf1)-1] = 0;
	strcat(buf3,buf1);
}


void dump_env(void)
{
	char *e1;
	printf("verbose \"Read In Variables: \" 1\n");
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_request");
	printf("verbose \"	agi_request = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_channel");
	printf("verbose \"	agi_channel = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_language");
	printf("verbose \"	agi_language = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_type");
	printf("verbose \"	agi_type = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_uniqueid");
	printf("verbose \"	agi_uniqueid = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_callerid");
	printf("verbose \"	agi_callerid = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_calleridname");
	printf("verbose \"	agi_calleridname = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_dnid");
	printf("verbose \"	agi_dnid = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_rdnis");
	printf("verbose \"	agi_rdnis = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_context");
	printf("verbose \"	agi_context = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_extension");
	printf("verbose \"	agi_extension = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_priority");
	printf("verbose \"	agi_priority = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_enhanced");
	printf("verbose \"	agi_enhanced = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

	e1 = getenv("agi_accountcode");
	printf("verbose \"	agi_accountcode = %s\" 1\n", e1);
	fflush(stdout);
	get_answer();

}


clean_string(char *s)
{
	int l = strlen(s);
	int i;
	for( i=l-1; i>=0; i--)
	{
		if( s[i] == ' ' || s[i] == '\t')
		{
			s[i] = 0;
		}
		else
		{
			break;
		}
	}
}

main(int argc,char **argv)
{
	char command[1024];
	char path[1024];
	char CIDnumbuf[1023];
	char CIDnambuf[1023];
	char *CIDnum,*z2;
	char *CIDnam;
	FILE *f;
	int i, international=0;

	get_vars(); /* read variables into the environment */
#ifdef DEBUG
	dump_env();
#endif

	strcpy(CIDnumbuf,getenv("agi_callerid"));
	strcpy(CIDnambuf,getenv("agi_calleridname"));
	CIDnum = CIDnumbuf;
	CIDnam = CIDnambuf;

#ifdef DEBUG
			printf("verbose \"CIDnum = %s\" 1\n", CIDnumbuf);
			fflush(stdout);
			get_answer();
			printf("verbose \"CIDnam = %s\" 1\n", CIDnambuf);
			fflush(stdout);
			get_answer();
#endif

#ifdef BAD_DREAM
	printf("get variable CONFCIDNU\n");
	fflush(stdout);
	get_answer(); /* buf3 has the result */
	z2 = strchr(buf3,'(');
	if( z2 )
	{
		strcpy(CIDnumbuf,z2+1);
		z2 = strchr(CIDnumbuf,')');
		if( z2 )
		{
			*z2 = 0;
			printf("verbose \"CIDnum = %s\" 1\n", CIDnumbuf);
			fflush(stdout);
			get_answer();
			CIDnum = CIDnumbuf;
		}
	}

	printf("get variable CONFCIDNA\n");
	fflush(stdout);
	get_answer();
	z2 = strchr(buf3,'(');
	if( z2 )
	{
		strcpy(CIDnambuf,z2+1);
		z2 = strchr(CIDnambuf,')');
		if( z2 )
		{
			*z2 = 0;
			printf("verbose \"CIDnam = %s\" 1\n", CIDnambuf);
			fflush(stdout);
			get_answer();
			CIDnam = CIDnambuf;
		}
	}
#endif
	clean_string(CIDnam);

	printf("stream file call-from \"\"\n");
	fflush(stdout);
	get_answer();
	
	/* the number may or may not start with a 1. If it does, do the equiv of skipping it */
	if( CIDnum[0] == '1' ) /* if the number starts with a 1, it's US, and that's where this program assumes you are */
		CIDnum++;

	if( CIDnum[0] == '0' && CIDnum[1] == '1' && CIDnum[2] == '1' )
	{
		international = 1;
		CIDnum += 3;
		printf("stream file CID-PLACES/international \"\"\n");
		fflush(stdout);
		get_answer();
	}

#ifdef TESTING
	f = fopen("/tmp/whoisit","w");
	if( f )
	{
		fprintf(f,"argc: %d;  arg0=%s,  arg1=%s,  ", argc, argv[0], argv[1]);
		for( i=2; i< argc; i++ )
			fprintf(f,"arg%d=%s,  ", i, argv[i]);
		fprintf(f,"\n");
		fclose(f);
	}
#endif
	if( !strcasecmp( CIDnam,"Privacy Manager") )
	{
		printf("stream file priv-unlisted \"\"\n");
		fflush(stdout);
		get_answer();
	}
	sprintf(path,"/var/lib/asterisk/sounds/priv-callerintros/%s.gsm", CIDnum);
	
	if( access(path,F_OK) == 0 )
	{
		printf("stream file priv-callerintros/%s \"\"\n", CIDnum);
		fflush(stdout);
		get_answer();
	}
	else
	{
		char areacode[4];
		char prefix[8];
		int i;

		
		if( international )
		{
			/* if the number started with 011, CIDnum now contains the remainder. */
			/* match the country code */
			for( i=1; i < 6; i++)
			{
				prefix[i-1] = CIDnum[i-1];
				prefix[i] = 0;
				sprintf(command,"/var/lib/asterisk/sounds/CID-PLACES/country-codes/%s.gsm", prefix);
				if( access(command,F_OK) == 0 )
				{
					printf("stream file CID-PLACES/country-codes/%s \"\"\n", prefix);
					fflush(stdout);
					get_answer();
				}
			}
		}
		else
		{
			strncpy(areacode,CIDnum, 3);
			areacode[3] = 0;
			
			for(i = 3; i< 6; i++)
				prefix[i-3] = CIDnum[i];
			prefix[3] = 0;
	
			printf("stream file unknowncallerfrom \"\"\n");
			fflush(stdout);
			get_answer();
			if( !strncmp(CIDnum,LOCAL_AREACODE,3) )
			{
				sprintf(path,"/var/lib/asterisk/sounds/CID-PLACES/%s/%s.gsm", areacode,prefix);
				if( access(path,F_OK) == 0 )
				{
					printf("stream file CID-PLACES/%s/%s \"\"\n", areacode,prefix);
					fflush(stdout);
					get_answer();
				}
				else
				{
					printf("stream file somewhereinstate \"\"\n");
					fflush(stdout);
					get_answer();
				}
			}
			else
			{
				sprintf(path,"/var/lib/asterisk/sounds/CID-PLACES/%s/%s.gsm", areacode,prefix);
				if( access(path,F_OK) == 0 )
				{
					printf("stream file CID-PLACES/%s/%s \"\"\n",areacode, prefix);
					fflush(stdout);
					get_answer();
				}
				else
				{
					sprintf(path,"/var/lib/asterisk/sounds/CID-PLACES/%s.gsm", areacode);
					if( access(path,F_OK) == 0 )
					{
						printf("stream file CID-PLACES/%s \"\"\n",areacode);
						fflush(stdout);
						get_answer();
					}
					else
					{
						printf("stream file somewhereoutstate \"\"\n");
						fflush(stdout);
						get_answer();
					}
				}
			}
		}
		if( CIDnam && strlen(CIDnam) )
		{
			/* write the CIDname field to a file, and play the file via tts in festival */
			printf("exec festival \"%s\"\n", CIDnam);
			fflush(stdout);
			get_answer();
		}	
	}
	printf("exec Hangup\n");
	fflush(stdout);
	get_answer();
	
	exit(0);
}
